module Timmer(
			clk_ltm,
			reset_n,
			x_cnt,
			y_cnt,
			state,
			oOVERRIDE,
			oADDR
			);

input clk_ltm;
input reset_n;
input [3:0] state;
input [10:0] x_cnt;
input [9:0] y_cnt;
output oOVERRIDE;
output [17:0] oADDR;
//PARAMETER
parameter BASE_ADDR = 89025;
parameter INIT = 4'b0100;
parameter START = 4'b0101;
parameter PAUSE = 4'b0110; 
parameter H_LINE = 1056;
parameter V_LINE = 525;
parameter Hsync_Blank = 216;
parameter Hsync_Front_Porch = 40;
parameter Vertical_Back_Porch = 35;
parameter Vertical_Front_Porch = 10; 
parameter clock_base = 18'd89039;
//WIRE & REG
reg [3:0] inumber_s;
reg [3:0] inumber_ts;
reg [3:0] inumber_min;
reg [26:0] counter;

wire [3:0] num_input_s;
wire [3:0] num_input_ts;
wire [3:0] num_input_min;
wire [26:0] oCNT;
wire [3:0] OVERRIDE;
wire flag1;
wire flag2;
wire [17:0] address;

symbol clock(				
				.iclk(clk_ltm),
				.ireset_n(reset_n),
				.ix_cnt(x_cnt),
				.iy_cnt(y_cnt),
				.isymbol_pos_x(Hsync_Blank-1+730),
				.isymbol_pos_y(Vertical_Back_Porch+10),
				.iBASE_ADDR(clock_base),
				.oOVERRIDE(OVERRIDE[3]),
				.oADDR(address)
);
//////////////////////Timmer/////////////////////////
number LED0(				
				.iclk(clk_ltm),
				.iReset_n(reset_n),
				.ixcount(x_cnt),
				.iycount(y_cnt),
				.iled_pos_x(Hsync_Blank-1+600),
				.iled_pos_y(Vertical_Back_Porch),
				.inumber(num_input_s),
				.oOVERRIDE(OVERRIDE[0])
);

number LED1(				
				.iclk(clk_ltm),
				.iReset_n(reset_n),
				.ixcount(x_cnt),
				.iycount(y_cnt),
				.iled_pos_x(Hsync_Blank-1+640),
				.iled_pos_y(Vertical_Back_Porch),
				.inumber(num_input_ts),
				.oOVERRIDE(OVERRIDE[1])
);

number LED2(				
				.iclk(clk_ltm),
				.iReset_n(reset_n),
				.ixcount(x_cnt),
				.iycount(y_cnt),
				.iled_pos_x(Hsync_Blank-1+680),
				.iled_pos_y(Vertical_Back_Porch),
				.inumber(num_input_min),
				.oOVERRIDE(OVERRIDE[2])
);

assign flag1 = (oCNT == 26'd24999999) ? 1'b1 : 1'b0;
assign flag2 = (inumber_s == 0) ? 1'b1 : 1'b0;
assign num_input_s = inumber_s;
assign num_input_ts = inumber_ts;
assign num_input_min = inumber_min;
assign oCNT = counter;


always@(posedge clk_ltm or negedge reset_n)
begin
	if(!reset_n)
	begin
	inumber_min <= 4'd2;
	inumber_ts <= 4'd0;
	inumber_s <= 4'd0;
	counter <= 26'b0;
	end
	else if(state == INIT)
	begin
	inumber_min <= 4'd2;
	inumber_ts <= 4'd0;
	inumber_s <= 4'd0;
	counter <= 26'b0;
	end
	else if(state == PAUSE)
	begin
	inumber_min <= inumber_min;
	inumber_ts <= inumber_ts;
	inumber_s <= inumber_s;
	end
	else if(state == START)
		begin
		if(flag1)
		begin
			if(flag2)
				begin
					if(inumber_ts != 0)
						begin
							inumber_ts <= inumber_ts - 1;
							inumber_s <= 4'd9;
							counter <= 26'b0;
						end
					else
						begin
							if(inumber_min != 0)
								begin
									inumber_min <= inumber_min -1;
									inumber_ts  <= 4'd5;
									inumber_s   <= 4'd9;
									counter <= 26'b0;
								end
							else
								begin
									inumber_min <= 4'd2;
									inumber_ts <= 4'd0;
									inumber_s <= 4'd0;
									counter <= 26'b0;
								end
						end
				end
			else
			begin
			inumber_s <= inumber_s-1;
			counter <= 26'b0;
			end
		end
	else
		counter <= counter +1;
	end
end

////OUTPUT 
assign oOVERRIDE = OVERRIDE[0] || OVERRIDE[1] || OVERRIDE[2] || OVERRIDE[3];
assign oADDR = (OVERRIDE[0] || OVERRIDE[1] || OVERRIDE[2]) ? BASE_ADDR:
					OVERRIDE[3] ? address : 18'bZ;

endmodule
