library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity musiccontroller is
port (

    clk        : in  std_logic;
    reset_n    : in  std_logic;
    read       : in  std_logic;
    write      : in  std_logic;
    chipselect : in  std_logic;
    address    : in  std_logic_vector(16 downto 0);
    readdata   : out std_logic_vector(15 downto 0);
    writedata  : in  std_logic_vector(15 downto 0);
    irq        : out std_logic;
	 

	AUD_ADCLRCK  : out  std_logic;   --    Audio CODEC ADC LR Clock
	AUD_ADCDAT   : in   std_logic;   --    Audio CODEC ADC Data
	AUD_DACLRCK  : out  std_logic;   --    Audio CODEC DAC LR Clock
	AUD_DACDAT   : out  std_logic;   --    Audio CODEC DAC Data
	AUD_BCLK     : inout std_logic; --    Audio CODEC Bit-Stream Clock
	AUD_XCK      : out std_logic;
	clk_18       : in std_logic
  );
  
  end musiccontroller;
  
  architecture mc of musiccontroller is
  
  signal audio_request : std_logic;
  signal audio_clock : unsigned(1 downto 0) := "00";
  signal store : std_logic;
--  signal clk_18:std_logic;


 
   component de2_wm8731_audio is port(
	       clk_chip : in std_logic;
		    clk : in std_logic;       --  Audio CODEC Chip Clock AUD_XCK (18.43 MHz)
    		 reset_n : in std_logic;
		    test_mode : in std_logic;       --    Audio CODEC controller test mode
		    audio_request : out std_logic_vector(15 downto 0);  --    Audio controller request new data
		    data       : in std_logic_vector(15 downto 0);
			 address    : in  std_logic_vector(16 downto 0);
			 write      : in std_logic;
			 chipselect : in std_logic;
   		 irq        : out std_logic;
  
		    -- Audio interface signals
    		 AUD_ADCLRCK  : out  std_logic;   --    Audio CODEC ADC LR Clock
		    AUD_ADCDAT   : in   std_logic;   --    Audio CODEC ADC Data
		    AUD_DACLRCK  : out  std_logic;   --    Audio CODEC DAC LR Clock
		    AUD_DACDAT   : out  std_logic;   --    Audio CODEC DAC Data
		    AUD_BCLK     : inout std_logic--      Audio CODEC Bit-Stream Clock

		 );
		 end component de2_wm8731_audio;
		 
		 
		 
		 component de2_audio_pll is
PORT
(
inclk0		: IN STD_LOGIC  := '0';
c0		: OUT STD_LOGIC 
);end component de2_audio_pll;



begin

 AUD_XCK <= clk_18;
 
process (clk)
  begin
   if rising_edge(clk) then
	   audio_clock <= audio_clock + "1";
	end if;
end process;

--	process (clk)
--	begin
--		if rising_edge(clk) then
--			if reset_n = '0' then
--				  store <= '0';
--			else
--				if chipSelect = '1' and write = '1'  then
--					store <= '1';				
--				end if;	
--			end if;
--		end if;
--	end process;


V1: de2_wm8731_audio port map (
    clk_chip => clk,
    clk => clk_18,
    reset_n   => '1',
    test_mode => '0',         
    audio_request => readdata,
    data =>  writedata ,
	 address => address,
	 write   => write,
	 chipselect => chipselect,
	 irq     =>  irq,
  
    -- Audio interface signals
    AUD_ADCLRCK  => AUD_ADCLRCK,
    AUD_ADCDAT   => AUD_ADCDAT,
    AUD_DACLRCK  => AUD_DACLRCK,
    AUD_DACDAT   => AUD_DACDAT,
    AUD_BCLK     => AUD_BCLK
  );
  
  
--  V2: de2_audio_pll port map(
--  inclk0 => clk_27,
--  c0     => clk_18
--  );
  end architecture;
  